VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSimpleMidi"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Simple Midi Class (found at PSC some time ago and heavily modified)

Private Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Attribute midiOutOpen.VB_Description = "Windows API"
Private Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, dwMsg As Any) As Long
Attribute midiOutShortMsg.VB_Description = "Windows API"
Private Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
Attribute midiOutClose.VB_Description = "Windows API"
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Attribute Sleep.VB_Description = "Windows API"

Private hMidi   As Long
Attribute hMidi.VB_VarDescription = "MIDI handle"

Private Type MM
    LL          As Byte
    LH          As Byte
    HL          As Byte
    HH          As Byte
End Type

Public Enum Inst

    'melody
    '------
    m_Acoustic_Grand_Piano = 0
    m_Bright_Acoustic_Piano = 1
    m_Electric_Grand_Piano = 2
    m_Honky_Tonk_Piano = 3
    m_Electric_Piano_1 = 4
    m_Electric_Piano_2 = 5
    m_Harpsichord = 6
    m_Clav = 7
    m_Celesta = 8
    m_Glockenspiel = 9
    m_Music_Box = 10
    m_Vibraphone = 11
    m_Marimba = 12
    m_Xylophone = 13
    m_Tubular_Bells = 14
    m_Dulcimer = 15
    m_Drawbar_Organ = 16
    m_Percussive_Organ = 17
    m_Rock_Organ = 18
    m_Church_Organ = 19
    m_Reed_Organ = 20
    m_Accordian = 21
    m_Harmonica = 22
    m_Tango_Accordeon = 23
    m_Nylon_Guitar = 24
    m_Steel_Guitar = 25
    m_Jazz_Electric_Guitar = 26
    m_Clean_Electric_Guitar = 27
    m_Muted_Electric_Guitar = 28
    m_Overdriven_Guitar = 29
    m_Distortion_Guitar = 30
    m_Guitar_Harmonics = 31
    m_Acoustic_Bass = 32
    m_Finger_Electric_Bass = 33
    m_Pick_Electric_Bass = 34
    m_Fretless_Bass = 35
    m_Slap_Bass_1 = 36
    m_Slap_Bass_2 = 37
    m_Synth_Bass_1 = 38
    m_Synth_Bass_2 = 39
    m_Violin = 40
    m_Viola = 41
    m_Cello = 42
    m_Contrabass = 43
    m_Tremolo_Strings = 44
    m_Pizzicato_Strings = 45
    m_Orchestral_Strings = 46
    m_Timpani = 47
    m_String_Ensemble_1 = 48
    m_String_Ensemble_2 = 49
    m_Synth_Strings_1 = 50
    m_Synth_Strings_2 = 51
    m_Choir_Aahs = 52
    m_Voice_Oohs = 53
    m_Synth_Voice = 54
    m_Orchestra_Hit = 55
    m_Trumpet = 56
    m_Trombone = 57
    m_Tuba = 58
    m_Muted_Trumpet = 59
    m_French_Horn = 60
    m_Brass_Section = 61
    m_Synth_Brass_1 = 62
    m_Synth_Brass_2 = 63
    m_Soprano_Sax = 64
    m_Alto_Sax = 65
    m_Tenor_Sax = 66
    m_Baritone_Sax = 67
    m_Oboe = 68
    m_English_Horn = 69
    m_Bassoon = 70
    m_Clarinet = 71
    m_Piccolo = 72
    m_Flute = 73
    m_Recorder = 74
    m_Pan_Flute = 75
    m_Blown_Bottle = 76
    m_Shakuhachi = 77
    m_Whistle = 78
    m_Ocarina = 79
    m_Lead_1_Square = 80
    m_Lead_2_Sawtooth = 81
    m_Lead_3_Calliope = 82
    m_Lead_4_Chiff = 83
    m_Lead_5_Charang = 84
    m_Lead_6_Voice = 85
    m_Lead_7_Fifths = 86
    m_Lead_8_Bass_lead = 87
    m_Pad_1_New_age = 88
    m_Pad_2_Warm = 89
    m_Pad_3_Polysynth = 90
    m_Pad_4_Choir = 91
    m_Pad_5_Bowed = 92
    m_Pad_6_Metallic = 93
    m_Pad_7_Halo = 94
    m_Pad_8_Sweep = 95
    m_FX_1_Rain = 96
    m_FX_2_Soundtrack = 97
    m_FX_3_Crystal = 98
    m_FX_4_Atmosphere = 99
    m_FX_5_Brightness = 100
    m_FX_6_Goblins = 101
    m_FX_7_Echoes = 102
    m_FX_8_Sci_fi = 103
    m_Sitar = 104
    m_Banjo = 105
    m_Shamisen = 106
    m_Koto = 107
    m_Kalimba = 108
    m_Bagpipe = 109
    m_Fiddle = 110
    m_Shanai = 111
    m_Tinkle_Bell = 112
    m_Agogo = 113
    m_Steel_Drums = 114
    m_Woodblock = 115
    m_Taiko_Drum = 116
    m_Melodic_Tom = 117
    m_Synth_Drum = 118
    m_Reverse_Cymbal = 119
    m_Guitar_Fret_Noise = 120
    m_Breath_Noise = 121
    m_Seashore = 122
    m_Bird_Tweet = 123
    m_Telephone_Ring = 124
    m_Helicopter = 125
    m_Applause = 126
    m_Gunshot = 127

    'percussion
    '----------
    p_Acoustic_Bass_Drum = 128
    p_Bass_Drum_1 = 129
    p_Side_Stick = 130
    p_Acoustic_Snare = 131
    p_Hand_Clap = 132
    p_Electric_Snare = 133
    p_Low_Floor_Tom = 134
    p_Closed_High_Hat = 135
    p_High_Floor_Tom = 136
    p_Pedal_High_Hat = 137
    p_Low_Tom = 138
    p_Open_High_Hat = 139
    p_Low_Mid_Tom = 140
    p_High_Mid_Tom = 141
    p_Crash_Cymbal_1 = 142
    p_High_Tom = 143
    p_Ride_Cymbal_1 = 144
    p_Chinese_Cymbal = 145
    p_Ride_Bell = 146
    p_Tambourine = 147
    p_Splash_Cymbal = 148
    p_Cowbell = 149
    p_Crash_Cymbal_2 = 150
    p_Vibraslap = 151
    p_Ride_Cymbal_2 = 152
    p_High_Bongo = 153
    p_Low_Bongo = 154
    p_Mute_High_Conga = 155
    p_Open_High_Conga = 156
    p_Low_Conga = 157
    p_High_Timbale = 158
    p_Low_Timbale = 159
    p_High_Agogo = 160
    p_Low_Agogo = 161
    p_Cabasa = 162
    p_Maracas = 163
    p_Short_Whistle = 164
    p_Long_Whistle = 165
    p_Short_Guiro = 166
    p_Long_Guiro = 167
    p_Claves = 168
    p_High_Wood_Block = 169
    p_Low_Wood_Block = 170
    p_Mute_Cuica = 171
    p_Open_Cuica = 172
    p_Mute_Triangle = 173
End Enum

Public Enum InstType
    Melody = 1
    Percussion = 2
End Enum

#If False Then 'to preserve capitalization

Private Melody
'-------------
Private m_Acoustic_Grand_Piano
Private m_Bright_Acoustic_Piano
Private m_Electric_Grand_Piano
Private m_Honky_Tonk_Piano
Private m_Electric_Piano_1
Private m_Electric_Piano_2
Private m_Harpsichord
Private m_Clav
Private m_Celesta
Private m_Glockenspiel
Private m_Music_Box
Private m_Vibraphone
Private m_Marimba
Private m_Xylophone
Private m_Tubular_Bells
Private m_Dulcimer
Private m_Drawbar_Organ
Private m_Percussive_Organ
Private m_Rock_Organ
Private m_Church_Organ
Private m_Reed_Organ
Private m_Accordian
Private m_Harmonica
Private m_Tango_Accordeon
Private m_Nylon_Guitar
Private m_Steel_Guitar
Private m_Jazz_Electric_Guitar
Private m_Clean_Electric_Guitar
Private m_Muted_Electric_Guitar
Private m_Overdriven_Guitar
Private m_Distortion_Guitar
Private m_Guitar_Harmonics
Private m_Acoustic_Bass
Private m_Finger_Electric_Bass
Private m_Pick_Electric_Bass
Private m_Fretless_Bass
Private m_Slap_Bass_1
Private m_Slap_Bass_2
Private m_Synth_Bass_1
Private m_Synth_Bass_2
Private m_Violin
Private m_Viola
Private m_Cello
Private m_Contrabass
Private m_Tremolo_Strings
Private m_Pizzicato_Strings
Private m_Orchestral_Strings
Private m_Timpani
Private m_String_Ensemble_1
Private m_String_Ensemble_2
Private m_Synth_Strings_1
Private m_Synth_Strings_2
Private m_Choir_Aahs
Private m_Voice_Oohs
Private m_Synth_Voice
Private m_Orchestra_Hit
Private m_Trumpet
Private m_Trombone
Private m_Tuba
Private m_Muted_Trumpet
Private m_French_Horn
Private m_Brass_Section
Private m_Synth_Brass_1
Private m_Synth_Brass_2
Private m_Soprano_Sax
Private m_Alto_Sax
Private m_Tenor_Sax
Private m_Baritone_Sax
Private m_Oboe
Private m_English_Horn
Private m_Bassoon
Private m_Clarinet
Private m_Piccolo
Private m_Flute
Private m_Recorder
Private m_Pan_Flute
Private m_Blown_Bottle
Private m_Shakuhachi
Private m_Whistle
Private m_Ocarina
Private m_Lead_1_Square
Private m_Lead_2_Sawtooth
Private m_Lead_3_Calliope
Private m_Lead_4_Chiff
Private m_Lead_5_Charang
Private m_Lead_6_Voice
Private m_Lead_7_Fifths
Private m_Lead_8_Bass_lead
Private m_Pad_1_New_age
Private m_Pad_2_Warm
Private m_Pad_3_Polysynth
Private m_Pad_4_Choir
Private m_Pad_5_Bowed
Private m_Pad_6_Metallic
Private m_Pad_7_Halo
Private m_Pad_8_Sweep
Private m_FX_1_Rain
Private m_FX_2_Soundtrack
Private m_FX_3_Crystal
Private m_FX_4_Atmosphere
Private m_FX_5_Brightness
Private m_FX_6_Goblins
Private m_FX_7_Echoes
Private m_FX_8_Sci_fi
Private m_Sitar
Private m_Banjo
Private m_Shamisen6
Private m_Koto
Private m_Kalimba
Private m_Bagpipe
Private m_Fiddle
Private m_Shanai
Private m_Tinkle_Bell
Private m_Agogo
Private m_Steel_Drums
Private m_Woodblock
Private m_Taiko_Drum
Private m_Melodic_Tom
Private m_Synth_Drum
Private m_Reverse_Cymbal
Private m_Guitar_Fret_Noise
Private m_Breath_Noise
Private m_Seashore
Private m_Bird_Tweet
Private m_Telephone_Ring
Private m_Helicopter
Private m_Applause
Private m_Gunshot

Private Percussion
'-----------------
Private p_Acoustic_Bass_Drum
Private p_Bass_Drum_1
Private p_Side_Stick
Private p_Acoustic_Snare
Private p_Hand_Clap
Private p_Electric_Snare
Private p_Low_Floor_Tom
Private p_Closed_High_Hat
Private p_High_Floor_Tom
Private p_Pedal_High_Hat
Private p_Low_Tom
Private p_Open_High_Hat
Private p_Low_Mid_Tom
Private p_High_Mid_Tom
Private p_Crash_Cymbal_1
Private p_High_Tom
Private p_Ride_Cymbal_1
Private p_Chinese_Cymbal
Private p_Ride_Bell
Private p_Tambourine
Private p_Splash_Cymbal
Private p_Cowbell
Private p_Crash_Cymbal_2
Private p_Vibraslap
Private p_Ride_Cymbal_2
Private p_High_Bongo
Private p_Low_Bongo
Private p_Mute_High_Conga
Private p_Open_High_Conga
Private p_Low_Conga
Private p_High_Timbale
Private p_Low_Timbale
Private p_High_Agogo
Private p_Low_Agogo
Private p_Cabasa
Private p_Maracas
Private p_Short_Whistle
Private p_Long_Whistle
Private p_Short_Guiro
Private p_Long_Guiro
Private p_Claves
Private p_High_Wood_Block
Private p_Low_Wood_Block
Private p_Mute_Cuica
Private p_Open_Cuica
Private p_Mute_Triangle
#End If

Private Instru              As Inst
Attribute Instru.VB_VarDescription = "An Instrument"
Private InstruType          As InstType
Attribute InstruType.VB_VarDescription = "Instrument type: melody or percussion"

Private Sub Class_Initialize()
Attribute Class_Initialize.VB_Description = "Called by VB on class instantiation"

    midiOutOpen hMidi, 0, 0, 0, 0
    Instru = -1
    InstruType = -1

End Sub

Private Sub Class_Terminate()
Attribute Class_Terminate.VB_Description = "Called by VB on class destruction"

    midiOutClose hMidi

End Sub

Public Property Get CurrentInstrument() As Inst
Attribute CurrentInstrument.VB_Description = "Returns the currently selected instrument"

    CurrentInstrument = Instru

End Property

Public Property Get CurrentInstrumentType() As InstType
Attribute CurrentInstrumentType.VB_Description = "Returns the currently selected instrument type"

    CurrentInstrumentType = InstruType

End Property

Private Function MidiMsg(ByVal HH As Byte, ByVal HL As Byte, ByVal LH As Byte, ByVal LL As Byte) As MM
Attribute MidiMsg.VB_Description = "Constructs a midi message"

    With MidiMsg
        .LL = LL
        .LH = LH
        .HL = HL
        .HH = HH
    End With 'MIDIMSG

End Function

Public Property Let NewInstrument(Instrument As Inst)
Attribute NewInstrument.VB_Description = "Sets the new Instrument"

    If Instrument <> Instru Then
        Instru = Instrument
        InstruType = IIf(Instru < 128, Melody, Percussion)
        midiOutShortMsg hMidi, ByVal MidiMsg(0, 0, 0, &HB0)
        midiOutShortMsg hMidi, ByVal MidiMsg(0, 0, &H32, &HB0)
        midiOutShortMsg hMidi, ByVal MidiMsg(0, 0, CByte(Instru), &HC0)
    End If

End Property

Public Sub PlayNote(ByVal Note As Byte, ByVal Volume As Byte, ByVal Duration As Long, Optional ByVal Instrument As Inst = -1)
Attribute PlayNote.VB_Description = "Plays a note"

  Dim Tmp As Byte

    If Instrument >= 0 Then
        NewInstrument = Instrument
    End If
    If InstruType = Percussion Then
        Tmp = Instrument - 93
      Else 'NOT INSTRUTYPE...
        Tmp = Note
    End If

    midiOutShortMsg hMidi, ByVal MidiMsg(0, Volume, Tmp, &H90) 'play note
    If Duration > 0 Then
        Sleep Duration
        midiOutShortMsg hMidi, ByVal MidiMsg(0, 0, Tmp, &H80) 'sound off
      Else 'NOT DURATION...
        'the note just fades away (well, not all instruments do that)
    End If

End Sub

':) Ulli's VB Code Formatter V2.17.4 (2004-Jul-30 19:12) 391 + 74 = 465 Lines
